#ifndef BASEOBJECT_H
#define BASEOBJECT_H

// #include "worldmodifier.h"
//#include "shape.h"
#include "tinyxml/tinyxml.h"

// class Shape;

class WorldModifier;
class Shape;

class BaseObject
{
	public:

	BaseObject (Shape* shape) { this->shape = shape; signature = 0; };
	virtual ~BaseObject () { }

	virtual void draw () =0;
	virtual void update (float delta_t, WorldModifier& worldmodifier) =0;
	virtual TiXmlNode& getXMLRepresentation () =0;
	Shape* getShape () { return shape; }
	void setSignature (long signature) { this->signature = signature; }
	long getSignature () { return signature; }

	protected:
	
	Shape* shape;
	long signature;
};

#endif // BASEOBJECT_H
