#ifndef BASIC_ANIMATIONS_H
#define BASIC_ANIMATIONS_H

#include "animation.h"

/**
 * Rotates clockwise when direction is positive and vice versa. Direction
 * is also sets the rotation speed.
 */
class Rotate : public Animation
{
	public:
	Rotate ();
	Rotate (float direction, float duration, float delay = 0.0);

	void set (float direction);
	void reset ();
	void exec (Outline& outline, Position& position, float delta_t);

	private:

	float direction;
	float acc;
};

class Scale : public Animation
{
	public:
	Scale (float sx, float sy, float duration, float delay = 0.0);
	
	void exec (Outline& outline, Position& position, float delta_t);

	private:

	float sx, sy;
};

class TranslateInst : public Animation
{
	public:
	TranslateInst ();
	TranslateInst (float x, float y, float duration, float delay = 0.0);

	void set (float x, float y);
	void exec (Outline& outline, Position& position, float delta_t);

	private:

	float x, y;
};

class ScaleInst : public Animation 
{
	public:
	ScaleInst ();
	ScaleInst (float sx, float sy, float duration, float delay = 0.0);

	void set (float sx, float sy);
	void exec (Outline& outline, Position& position, float delta_t);

	private:

	float sx, sy;
};

#endif // BASIC_ANIMATIONS_H
