#ifndef COLLISIONDETECTOR_H
#define COLLISIONDETECTOR_H

#include <map>
#include <vector>

#include "worldmodifier.h"
#include "baseobject.h"
#include "player.h"
#include "defines.h"

// #define Tilemap vector< vector<BaseObject*> > 
// #define FreeObjects vector<BaseObject*> 

using namespace std;

class CollisionDetector
{
	public:
	
	CollisionDetector (Player* player, float tile_size);
	~CollisionDetector ();

	
	void runAgainst (Tilemap& tilemap, WorldModifier& worldmodifier, float delta_t);
	void runAgainst (FreeObjects& freeobjects, WorldModifier& worldmodifier, float delta_t);

	private:

	float tile_size;

	int getUpperRow ();
	int getLowerRow ();

 	Player* player;
};

#endif // COLLISIONDETECTOR_H
