#include <iostream>
#include <cmath>

#include "cursor.h"
#include "renderutil.h"
#include "worldmodifier.h"

using namespace std;

Cursor::Cursor (float x, float y)
	:
	BaseObject (&cursorshape),
	cursorshape (this)
{
	cursorshape.x = x;
	cursorshape.y = y;
	cursorshape.sidelength = 0.1;
}

Cursor::~Cursor ()
{
}

void Cursor::draw ()
{
	RenderUtil::renderSquare (cursorshape.x,
									  cursorshape.y,
									  cursorshape.sidelength, "data/gfx/cursor.png");
}

TiXmlNode& Cursor::getXMLRepresentation ()
{
	TiXmlElement cursor_node ("cursor_node");

	return cursor_node;
}

void Cursor::setPosition (float x, float y)
{
	cursorshape.x = x;
	cursorshape.y = y;
}

