#include <iostream>

#include "edge.h"
#include "renderutil.h"
#include "worldmodifier.h"

using namespace std;

Edge::Edge (float x, float y)
	:
	BaseObject (&edgeshape)
{
	edgeshape.x = x;
	edgeshape.y = y;
}

Edge::~Edge ()
{
}

void Edge::draw ()
{
	RenderUtil::renderRectangle (edgeshape.x,
										  edgeshape.y,
										  10.0, 0.4, "data/gfx/edge.png");
}

TiXmlNode& Edge::getXMLRepresentation ()
{
	TiXmlElement edge_node ("edge");

	return edge_node;
}

void Edge::setPosition (float x, float y)
{
	edgeshape.x = x;
	edgeshape.y = y;
}

void Edge::EdgeShape::manipulate (Player* player, WorldModifier& worldmodifier, float delta_t)
{
	/* do nothing */
}
