#ifndef FALLINGROCK_H
#define FALLINGROCK_H

#include "baseobject.h"
#include "player.h"
#include "square.h"
#include "rock.h"

class FallingRock : public BaseObject
{
	public:
	FallingRock (float x, float y, Rocktype type);
	~FallingRock ();

	virtual void draw ();
	virtual void update (float delta, WorldModifier& worldmodifier);
	virtual TiXmlNode& getXMLRepresentation ();

	private:

	float vertical_velocity;
	float lifetime;
	Rocktype type;

	class RockShape;
	friend class RockShape;

	class RockShape : public Square
	{
		public:
		RockShape (FallingRock* rock_p) { this->rock_p = rock_p; }
		
		void manipulate (Player* player, WorldModifier& worldmodifier, float delta_t);

		private:
		FallingRock* rock_p;
	}rockshape;
};

#endif // FALLINGROCK_H
