#ifndef GAME_H
#define GAME_H

// #include <vector>
// #include <map>

// #include "defines.h"
#include "hud/hud.h"
#include "edge.h"
#include "world.h"
#include "player.h"
#include "animation.h"
// #include "worldmodifier.h"
#include "objectfactory.h"
// #include "baseobject.h"
#include "renderer.h"
#include "inputcontroller.h"
#include "collisiondetector.h"

// #define Tilemap vector< vector<BaseObject*> > 
// #define FreeObjects map<long, BaseObject*> 

using namespace std;

enum GameState {
	START,
	MAIN_LOOP,
	END_SEQUENCE,
	SHOW_SCORE,
	GAME_OVER,
	WAIT_UNTIL_EXIT
};

class Game : public World {
	public:

	Game (const char* levelfile);
	~Game ();

	void loop ();
	void loadLevel (const char* levelfile);

	int getScore () { return score; }
	
	private:

	void update ();
	void updateHud ();
	void adjustCamera ();
	void insertObject (BaseObject* object);

	float timer;
	float delta_t;
	float viewport_x;
	float viewport_y;
	float zoom;

	float cam_curr;
	float cam_prev;

	int score;

	GameState gamestate;
	Player player;
	Edge edge;

	CollisionDetector collisiondetector;
	InputController inputcontroller;
	WorldModifier worldmodifier;
	ObjectFactory objectfactory;
	AnimationSystem animationsystem;
	Renderer renderer;
	Hud hud;
};

#endif // GAME_H
