#ifndef GOAL_H
#define GOAL_H

#include "baseobject.h"
#include "player.h"
#include "square.h"

class Goal : public BaseObject
{
	public:
	Goal (float x, float y);
	Goal (TiXmlElement* goal_node);
	~Goal ();

	virtual void draw ();
	virtual void update (float delta_t, WorldModifier& worldmodifier) { }
	void setPosition (float x, float y);
	TiXmlNode& getXMLRepresentation ();


	private:

	class GoalShape;
	friend class GoalShape;

	class GoalShape : public Square
	{
		public:
		GoalShape (Goal* goal_p) { this->goal_p = goal_p; }
		
		void manipulate (Player* player, WorldModifier& worldmodifier, float delta_t);

		private:
		Goal* goal_p;
	}goalshape;
};

#endif // GOAL_H
