#ifndef HUD_H
#define HUD_H

#include <map>
#include <vector>

#include "widget.h"

#define Layer  map<string, SimpleHud::Widget*>

using std::map;
using std::vector;

class Hud
{
	public:

	Hud (const char* hud_scheme);
	~Hud ();

	void draw ();
	
	static void registerWidget (SimpleHud::Widget* widget, string id, int layer);
	static void sendMessage (string widget, string message);
	static void sendMessage (string widget, float message);
	static void turnOff (string id);
	static void turnOn (string id);

	private:

	void set2dMode ();
	void unset2dMode ();

	static vector< Layer > layers;

	float width;
	float height;
};

#endif // HUD_H
