#ifndef HUD_METER
#define HUD_METER

#include "widget.h"
#include "widgetfactory.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleHud
{
	class Meter : public Widget
	{
		public:
	
		Meter (TiXmlElement* widget_node);
		virtual ~Meter ();

		void draw ();
		void handleMessage (float message);

		private:

		class MeterFactory : public WidgetFactory
		{
			public:	

			MeterFactory ()
				: WidgetFactory ("meter", this) { }

			void _create (TiXmlElement* widget_node)
			{
				new Meter (widget_node);
			}
		};

		static MeterFactory meter_factory;

		float x, y;
		float w, h;

		float percent;

		string meter_texture;
		string frame_texture;
	};
}

#endif // HUD_METER
