#include <stdexcept>

#include "splashimage.h"
#include "../renderutil.h"

using std::domain_error;
using namespace SimpleHud;

SplashImage::SplashImageFactory SplashImage::splash_image_factory;
	
SplashImage::SplashImage (TiXmlElement* widget_node)
	:
	Widget (widget_node)
{
	if (widget_node->Attribute ("image"))
		splash_image = widget_node->Attribute ("image");
	else
		throw domain_error ("SplashImage: missing 'image' tag");

	if (widget_node->QueryFloatAttribute ("x", &x) != TIXML_SUCCESS)
		throw domain_error ("SplashImage: missing 'x' tag");

	if (widget_node->QueryFloatAttribute ("y", &y) != TIXML_SUCCESS)
		throw domain_error ("SplashImage: missing 'y' tag");

	if (widget_node->QueryFloatAttribute ("width", &w) != TIXML_SUCCESS)
		throw domain_error ("SplashImage: missing 'width' tag");

	if (widget_node->QueryFloatAttribute ("height", &h) != TIXML_SUCCESS)
		throw domain_error ("SplashImage: missing 'height' tag");
}

SplashImage::~SplashImage ()
{
	/* nothing */
}

void SplashImage::draw ()
{
	RenderUtil::renderRectangle (x, y, w/2.0, h/2.0, splash_image.c_str ());
}

void SplashImage::handleMessage (string message)
{
	splash_image = message;
}
