#ifndef SPLASH_IMAGE
#define SPLASH_IMAGE

#include "widget.h"
#include "widgetfactory.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleHud
{
	class SplashImage : public Widget
	{
		public:
	
		SplashImage (TiXmlElement* widget_node);
		virtual ~SplashImage ();

		void draw ();
		void handleMessage (string message);

		private:

		class SplashImageFactory : public WidgetFactory
		{
			public:	

			SplashImageFactory ()
				: WidgetFactory ("splash-image", this) { }

			void _create (TiXmlElement* widget_node)
			{
				new SplashImage (widget_node);
			}
		};

		static SplashImageFactory splash_image_factory;

		float x, y;
		float w, h;

		string splash_image;
	};
}

#endif // SPLASH_IMAGE
