#ifndef HUD_TEXT
#define HUD_TEXT

#include "widget.h"
#include "widgetfactory.h"
#include "../renderutil.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleHud
{
	class Text : public Widget
	{
		public:
	
		Text (TiXmlElement* widget_node);
		virtual ~Text ();

		void draw ();
		void handleMessage (string message);

		private:

		class TextFactory : public WidgetFactory
		{
			public:	

			TextFactory ()
				: WidgetFactory ("text", this) { }

			void _create (TiXmlElement* widget_node)
			{
				new Text (widget_node);
			}
		};

		static TextFactory text_factory;

		float x, y;
		float size;

		bool cache_text;

		string text;
		string font;

		RenderUtil::TextAlignment text_alignment;
	};
}

#endif // HUD_TEXT
