#include <stdexcept>

#include "widget.h"
#include "hud.h"

using std::domain_error;

using namespace SimpleHud;

Widget::Widget (TiXmlElement* widget_node)
	:
	status (true)
{
	int layer;

	if (widget_node->Attribute ("id"))
		id = widget_node->Attribute ("id");
	else
		throw domain_error ("Widget: missing 'id' tag");

	if (widget_node->Attribute ("status")) {
		if (strcmp (widget_node->Attribute ("status"), "on") == 0)
			status = true;
		else if (strcmp (widget_node->Attribute ("status"), "off") == 0)
			status = false;
	}

	if (widget_node->QueryIntAttribute ("layer", &layer) != TIXML_SUCCESS)
		throw domain_error ("Widget: missing layer attribute");

	Hud::registerWidget (this, id, layer);
}

Widget::~Widget ()
{
	/* nothing */
}

void Widget::handleMessage (string message)
{
	/* this widget ignore all messages */
}

void Widget::handleMessage (float message)
{
	/* this widget ignore all messages */
}

string Widget::getID ()
{
	return id;
}

void Widget::setStatus (bool on_off)
{
	status = on_off;
}

bool Widget::getStatus ()
{
	return status;
}
