#ifndef HUD_WIDGET_H
#define HUD_WIDGET_H

#include <iostream>

#include "../tinyxml/tinyxml.h"

using std::string;

namespace SimpleHud
{
	class Widget
	{
		public:

		Widget (TiXmlElement* widget_node);
		virtual ~Widget ();

		virtual void draw () = 0;
		virtual void handleMessage (string message);
		virtual void handleMessage (float message);

		string getID ();

		void setStatus (bool on_off);
		bool getStatus ();

		protected:

		string id;

		private:

		bool status;
	};
}

#endif // HUD_WIDGET_H
