#include <stdexcept>

#include "widgetfactory.h"

using std::domain_error;

using namespace SimpleHud;

WidgetFactory::WidgetFactory (string identifier, WidgetFactory* factory)
{
	factoryRegister ().insert (make_pair(identifier, factory));
}

map<string, WidgetFactory*>& WidgetFactory::factoryRegister ()
{
	static map<string, WidgetFactory*>* p_register = new map<string, WidgetFactory*>;

	return *p_register;
}

void WidgetFactory::create (TiXmlElement* widget_node)
{
	map<string, WidgetFactory*>::iterator widget_factory;
	
	widget_factory = factoryRegister().find (widget_node->Value ());

	if (widget_factory != factoryRegister().end ()) {
		widget_factory->second->_create (widget_node);
	}
	else {
		throw domain_error ("WidgetFactory: recieved undefined object - " + string(widget_node->Value ()));
	}
}
