#ifndef WIDGET_FACTORY_H
#define WIDGET_FACTORY_H

#include <map>
#include <string>

#include "../tinyxml/tinyxml.h"

using std::map;
using std::string;

namespace SimpleHud
{
	class WidgetFactory 
	{
		public:

		WidgetFactory (string, WidgetFactory*);
		virtual ~WidgetFactory () { /* nothing */ }

		virtual void _create (TiXmlElement* menu_node) = 0;
		static void create (TiXmlElement* menu_node);

		private:

		static map<string, WidgetFactory*>& factoryRegister ();
	};
}


#endif // FACTORY_H
