#ifndef INPUT_CONTROLLER_H
#define INPUT_CONTROLLER_H

#include <string>
#include <SDL/SDL.h>

using namespace std;

class InputController
{
	public:
	InputController ();
	~InputController ();
	
	/**
	 * update key state and mouse state
	 */
	void readInput ();
	void flushInputString () { inputstring.clear (); }
	string getInputString () { return inputstring; }

	bool digit (int d);
	bool digits[10];
	
	bool quit;
	bool left;
	bool right;
	bool jump;
	bool pause;
	bool rshift;
	bool textmode;
	bool return_pressed;
	bool mouse_moved;
	float motion_x;
	float motion_y;
	float mouse_x;
	float mouse_y;
	float left_click;
	float right_click;
	float wheel_up;
	float wheel_down;
	
	private:
	SDL_Event event;
	string inputstring;
	bool jumpkey;
};

#endif // INPUT_CONTROLLER_H
