#ifndef ABSOLUTE_FRAME
#define ABSOLUTE_FRAME

#include <list>

#include "frame.h"
#include "menufactory.h"

using namespace std;

namespace SimpleMenu {

	class AbsoluteFrame : public Frame
	{
		public:

		AbsoluteFrame (TiXmlElement* menu_node, Frame* parent);
		virtual ~AbsoluteFrame ();

		void draw (float w, float h, float x, float y);
		void drawBackdrop (float w, float h, float x, float y);
		void handleKeyPress (SDL_keysym key);
		void selected ();
		void selectPrev ();
		void selectNext ();
		void selectLeft ();
		void selectRight ();

		protected:

		list<Frame*>::iterator selected_object;
		list<Frame*> content;

		private:

		class AbsoluteFrameFactory : public Factory
		{
			public:	

			AbsoluteFrameFactory ()
				: Factory ("absolute-frame", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new AbsoluteFrame (menu_node, parent);
			}
		};

		static AbsoluteFrameFactory absolute_frame_factory;
		bool no_selectable_frames;
		string backdrop;
	};
}

#endif // ABSOLUTE_FRAME
