#include <iostream>

#include "frame.h"
#include "button.h"
#include "menusystem.h"
#include "../renderutil.h"

using namespace std;
using namespace SimpleMenu;

Button::ButtonFactory Button::button_factory;

Button::Button ()
{
	/* nothing */
}

Button::Button (TiXmlElement* menu_node, Frame* parent)
{
	TiXmlElement* work_node;

	this->parent = parent;
	this->id = menu_node->Attribute("id");

	work_node = menu_node->FirstChildElement ("default-img");
	default_img = work_node->Attribute("src");

	work_node = menu_node->FirstChildElement ("select-img");
	select_img = work_node->Attribute("src");

	texture = default_img;

	//MenuSystem::registerWidget (this);
}

Button::~Button ()
{
	/* nothing */
}

void Button::draw (float w, float h, float x, float y)
{
	RenderUtil::renderRectangle (x, y, w/2.0, h/2.0, texture.c_str ());
}

void Button::handleKeyPress (SDL_keysym key)
{
	switch (key.sym)
	{
		case SDLK_DOWN:
			texture = default_img;
			parent->selectNext ();
		break;

		case SDLK_UP:
			texture = default_img;
			parent->selectPrev ();
		break;
	
		case SDLK_RETURN:
			if (callback != 0) {
				callback->execute ();
			}
			else {
				cout << "should have executed callback if it was defined" << endl;
			}
		break;

		default:
			// meeh
		break;
	}
}

void Button::selected ()
{
	texture = select_img;
}
