#ifndef BUTTON_H
#define BUTTON_H

#include "widget.h"
#include "menufactory.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleMenu
{
	class Button : public Widget
	{
		public:

		Button ();
		Button (TiXmlElement* menu_node, Frame* parent);
		~Button ();

		void draw (float w, float h, float x, float y);
		void handleKeyPress (SDL_keysym key);
		void selected ();

		protected:

		string texture;
		string default_img;
		string select_img;

		private:

		class ButtonFactory : public Factory
		{
			public:	

			ButtonFactory ()
				: Factory ("button", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new Button (menu_node, parent);
			}
		};

		static ButtonFactory button_factory;
	};
}

#endif // BUTTON_H
