#ifndef FILE_VIEW_H
#define FILE_VIEW_H

#include <iostream>
#include <string>

#include "scrollframe.h"
#include "menufactory.h"

using std::string;

namespace SimpleMenu
{
	class FileView : public ScrollFrame
	{
		public:

		FileView (TiXmlElement* menu_node, Frame* parent);
		virtual ~FileView ();

		private:

		class FileViewFactory : public Factory
		{
			public:	

			FileViewFactory ()
				: Factory ("file-view", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new FileView (menu_node, parent);
			}
		};

		static FileViewFactory file_view_factory;

		string directory_path;
	};
}

#endif // FILE_VIEW_H
