#ifndef FRAME_H
#define FRAME_H

#include <SDL/SDL.h>

#include "../tinyxml/tinyxml.h"
#include "menuobject.h"

using namespace std;

namespace SimpleMenu
{
	class Frame : public MenuObject
	{
		public:

		Frame (Frame* parent);
		virtual ~Frame ();

		virtual void selected ();
		virtual void selectPrev () = 0;
		virtual void selectNext () = 0;
		virtual void selectLeft () = 0;
		virtual void selectRight () = 0;
		virtual void reset ();

		float getWidth () { return width; }
		float getHeight () { return height; }
		float getPositionX () { return position_x; }
		float getPositionY () { return position_y; }

		void setSelectable (bool selectable) { this->selectable = selectable; }
		bool isSelectable () { return selectable; }

		protected:

		float width;
		float height;

		float position_x;
		float position_y;

		private:

		bool selectable;
	};
}

#endif // FRAME_H
