#ifndef HIGHSCORE_VIEW
#define HIGHSCORE_VIEW

#include <iostream>

#include "scrollframe.h"
#include "menufactory.h"

using std::string;

namespace SimpleMenu
{
	class HighScoreView : public ScrollFrame
	{
		public:

		HighScoreView (TiXmlElement* menu_node, Frame* parent);
		virtual ~HighScoreView ();

		private:

		class HighScoreViewFactory : public Factory
		{
			public:	

			HighScoreViewFactory ()
				: Factory ("highscore-view", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new HighScoreView (menu_node, parent);
			}
		};

		static HighScoreViewFactory highscore_view_factory;

		string highscore_list;
	};
}

#endif // HIGHSCORE_VIEW
