#include "horizontaldynamicframe.h"

using namespace SimpleMenu;

HorizontalDynamicFrame::HorizontalDynamicFrameFactory HorizontalDynamicFrame::horizontal_dynamic_frame_factory;

HorizontalDynamicFrame::HorizontalDynamicFrame (TiXmlElement* menu_node, Frame* parent)
	: DynamicFrame (menu_node, parent)
{
	/* nothing */
}

HorizontalDynamicFrame::~HorizontalDynamicFrame ()
{
	/* nothing */
}

void HorizontalDynamicFrame::drawContent (float w, float h, float x, float y)
{
	float width = w / content.size ();
	float position_x = x - w / 2 + width / 2;

	for (list<MenuObject*>::iterator it = content.begin (); it != content.end (); it++) {
		(*it)->draw (width, h, position_x, y);
		position_x += width;
	}
}

void HorizontalDynamicFrame::selectPrev ()
{
	parent->selectPrev ();
}

void HorizontalDynamicFrame::selectNext ()
{
	parent->selectNext ();
}

void HorizontalDynamicFrame::selectLeft ()
{
	if (selected_object == content.begin ()) {
		selected_object = --content.end ();
	}
	else {
		selected_object--;
	}

	(*selected_object)->selected ();
}

void HorizontalDynamicFrame::selectRight ()
{
	if (selected_object == --content.end ()) {
		selected_object = content.begin ();
	}
	else {
		selected_object++;
	}

	(*selected_object)->selected ();
}
