#ifndef HORIZONTAL_DYNAMIC_FRAME
#define HORIZONTAL_DYNAMIC_FRAME

#include "dynamicframe.h"

namespace SimpleMenu
{
	class HorizontalDynamicFrame : public DynamicFrame
	{
		public:

		HorizontalDynamicFrame (TiXmlElement* menu_node, Frame* parent);
		virtual ~HorizontalDynamicFrame ();

		void selectPrev ();
		void selectNext ();
		void selectLeft ();
		void selectRight ();

		protected:

		void drawContent (float w, float h, float x, float y);

		private:

		class HorizontalDynamicFrameFactory : public Factory
		{
			public:	

			HorizontalDynamicFrameFactory ()
			:	Factory ("horizontal-dynamic-frame", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new HorizontalDynamicFrame (menu_node, parent);
			}
		};

		static HorizontalDynamicFrameFactory horizontal_dynamic_frame_factory;
	};
}

#endif // HORIZONTAL_DYNAMIC_FRAME
