#ifndef INPUT_BUTTON_H
#define INPUT_BUTTON_H

#include <iostream>
#include <string>

#include "textbutton.h"
#include "menufactory.h"
#include "../tinyxml/tinyxml.h"

using std::string;

namespace SimpleMenu
{
	class InputButton : public TextButton
	{
		public:

		InputButton (TiXmlElement* menu_node, Frame* parent);
		~InputButton ();

		void handleKeyPress (SDL_keysym key);
		
		protected:

		bool inputstate;

		private:

		class InputButtonFactory : public Factory
		{
			public:

			InputButtonFactory ()
				: Factory ("input-button", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new InputButton (menu_node, parent);
			}
		};

		static InputButtonFactory input_button_factory;

		int char_count;
		int char_input_limit;
	};
}

#endif // INPUT_BUTTON_H
