#ifndef LEVEL_VIEW
#define LEVEL_VIEW

#include <iostream>

#include "scrollframe.h"
#include "menufactory.h"

using std::string;

namespace SimpleMenu
{
	class LevelView : public ScrollFrame
	{
		public:

		LevelView (TiXmlElement* menu_node, Frame* parent);
		virtual ~LevelView ();

		private:

		class LevelViewFactory : public Factory
		{
			public:	

			LevelViewFactory ()
				: Factory ("level-view", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new LevelView (menu_node, parent);
			}
		};

		static LevelViewFactory level_view_factory;

		string level_progress_file;
	};
}

#endif // LEVEL_VIEW 
