#include <stdexcept>

#include "menufactory.h"
#include "button.h"
#include "textbutton.h"
#include "scrollframe.h"
#include "dynamicframe.h"
#include "fileview.h"
#include "menuswitchbutton.h"

using namespace SimpleMenu;

Factory::Factory (string identifier, Factory* factory)
{
	factoryRegister ().insert (make_pair(identifier, factory));
}

map<string, Factory*>& Factory::factoryRegister ()
{
	static map<string, Factory*>* p_register = new map<string, Factory*>;

	return *p_register;
}

MenuObject* Factory::create (TiXmlElement* menu_node, Frame* parent)
{
	map<string, Factory*>::iterator menu_factory;
	
	menu_factory = factoryRegister().find (menu_node->Value ());

	if (menu_factory != factoryRegister().end ()) {
		return menu_factory->second->_create (menu_node, parent);
	}
	else {
		throw domain_error ("MenuFactory: recieved undefined object - " + string(menu_node->Value ()));
	}
}
