#ifndef FACTORY_H
#define FACTORY_H

#include <map>
#include <string>

#include "frame.h"
#include "menuobject.h"

using std::map;
using std::string;

namespace SimpleMenu
{
	class Factory 
	{
		public:
		Factory (string, Factory*);
		virtual ~Factory () { /* nothing */ }

		virtual MenuObject* _create (TiXmlElement* menu_node, Frame* parent) = 0;
		static MenuObject* create (TiXmlElement* menu_node, Frame* parent);

		private:

		static map<string, Factory*>& factoryRegister ();
	};
}

#endif // FACTORY_H
