#include <iostream>

#include "menuswitchbutton.h"
#include "menusystem.h"

using namespace std;
using namespace SimpleMenu;

MenuSwitchButton::MenuSwitchButtonFactory MenuSwitchButton::menu_swich_button_factory;

MenuSwitchButton::MenuSwitchButton (TiXmlElement* menu_node, Frame* parent)
{
	TiXmlElement* work_node;

	this->parent = parent;
	this->id = menu_node->Attribute("id");

	work_node = menu_node->FirstChildElement ("default-img");
	default_img = work_node->Attribute("src");

	work_node = menu_node->FirstChildElement ("select-img");
	select_img = work_node->Attribute("src");

	work_node = menu_node->FirstChildElement ("switch-to");
	menu_link = work_node->Attribute("menu");

	texture = default_img;

	//MenuSystem::registerWidget (this);

	cout << "Creating ButtonSwitcher (" + id + ")" << endl;
}

MenuSwitchButton::~MenuSwitchButton ()
{
	/* nothing */
}

void MenuSwitchButton::handleKeyPress (SDL_keysym key)
{
	switch (key.sym)
	{
		case SDLK_DOWN:
			texture = default_img;
			parent->selectNext ();
		break;

		case SDLK_UP:
			texture = default_img;
			parent->selectPrev ();
		break;
	
		case SDLK_RETURN:
			MenuSystem::showMenu (menu_link);
		break;

		default:
			// meeh
		break;
	}
}
