#ifndef MENU_SWiTCH_BUTTON_H
#define MENU_SWiTCH_BUTTON_H

#include "button.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleMenu
{
	class MenuSwitchButton : public Button
	{
		public:

		MenuSwitchButton (TiXmlElement* menu_node, Frame* parent);
		~MenuSwitchButton ();

		void handleKeyPress (SDL_keysym key);

		protected:
	
		string menu_link;

		private:

		class MenuSwitchButtonFactory : public Factory
		{
			public:	

			MenuSwitchButtonFactory ()
				: Factory ("menu-switch-button", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new MenuSwitchButton (menu_node, parent);
			}
		};

		static MenuSwitchButtonFactory menu_swich_button_factory;
	};
}

#endif // MENU_SWiTCH_BUTTON_H
