#ifndef MENU_SYSTEM_H
#define MENU_SYSTEM_H

#include <list>
#include <stack>

#include "root.h"
#include "widget.h"

using namespace std;
using namespace SimpleMenu;

struct Menu {
	string id;
	list<Widget*> widgets;
	Root* root;
};

class MenuSystem
{
	public:

	MenuSystem ();
	~MenuSystem ();

	bool quitSignal ();
	void update ();
	void shutdown ();

	static void loadMenu (const char* scheme);
	static void showMenu (string id);
	static void popMenuHistory ();

	void setCallback (string menu, string widget, Callback* callback);

	static void registerWidget (Widget* widget);

	private:

	void checkForInput ();
	void set2dMode ();
	void unset2dMode ();
	
	bool quit;
	SDL_Event event;

	static stack<Menu*> menu_history;
	static list<Menu*> menus;
};

#endif // MENU_SYSTEM_H
