#include <iostream>

#include "scrollframe.h"

using namespace std;
using namespace SimpleMenu;

ScrollFrame::ScrollFrameFactory ScrollFrame::scroll_frame_factory;

ScrollFrame::ScrollFrame (TiXmlElement* menu_node, Frame* parent)
	:
	DynamicFrame (menu_node, this)
{
	menu_node->QueryIntAttribute ("visible-rows", &num_visible_rows);

	top_visible_object = selected_object;
	if (selected_object != content.end ())
		(*selected_object)->selected ();
}

ScrollFrame::~ScrollFrame ()
{
	/* nothing */
}

void ScrollFrame::drawContent (float w, float h, float x, float y)
{
	float height = h / num_visible_rows;
	float position_y = y - h / 2 + height / 2;

	int counter = 0;
	list<MenuObject*>::iterator it = top_visible_object;
	while (it != content.end () && counter < num_visible_rows) {
		(*it)->draw (w, height, x, position_y);
		position_y += height;
		counter++;
		it++;
	}
}

void ScrollFrame::selectPrev ()
{
	if (selected_object != content.begin ()) {
		if (top_visible_object == selected_object) {
			selected_object--;
			top_visible_object = selected_object;
		}
		else {
			selected_object--;
		}
	}

	(*selected_object)->selected ();
}

void ScrollFrame::selectNext ()
{
	if (selected_object != --content.end ()) {
		list<MenuObject*>::iterator count_object = top_visible_object;
		
		
		for (int i = 1; i < num_visible_rows && count_object != content.end (); i++) {
			count_object++;
		}

		if (count_object == selected_object) {
			selected_object++;
			top_visible_object++;
		}
		else {
			selected_object++;
		}
	}

	(*selected_object)->selected ();
}

void ScrollFrame::reset ()
{
	selected_object = content.begin ();
	top_visible_object = content.begin ();
}
