#ifndef SCROLL_FRAME
#define SCROLL_FRAME

#include <iostream>

#include "dynamicframe.h"
#include "menufactory.h"
#include "../tinyxml/tinyxml.h"

namespace SimpleMenu
{
	class ScrollFrame : public DynamicFrame
	{
		public:
		ScrollFrame (TiXmlElement* menu_node, Frame* parent);
		virtual ~ScrollFrame ();

		void selectPrev ();
		void selectNext ();
		void reset ();

		protected:

		void drawContent (float w, float h, float x, float y);

		private:

		class ScrollFrameFactory : public Factory
		{
			public:	

			ScrollFrameFactory ()
			:	Factory ("scroll-frame", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new ScrollFrame (menu_node, parent);
			}
		};

		static ScrollFrameFactory scroll_frame_factory;

		int num_visible_rows;
		list<MenuObject*>::iterator top_visible_object;
	};
}

#endif // SCROLL_FRAME
