#include <iostream>
#include <stdexcept>

#include "switchtextbutton.h"
#include "menusystem.h"

using namespace std;
using namespace SimpleMenu;

SwitchTextButton::SwitchTextButtonFactory SwitchTextButton::switch_text_button_factory;

SwitchTextButton::SwitchTextButton (TiXmlElement* menu_node, Frame* parent)
	:
	TextButton (menu_node, parent)
{
	this->parent = parent;

	if (menu_node->Attribute("link") != NULL)
		this->link = menu_node->Attribute("link");
	else
		throw domain_error ("SwitchTextButton: Missing link property");
}

SwitchTextButton::~SwitchTextButton ()
{
	/* nothing */
}

void SwitchTextButton::handleKeyPress (SDL_keysym key)
{
	switch (key.sym)
	{
		case SDLK_DOWN:
			texture = background_texture;
			parent->selectNext ();
		break;

		case SDLK_UP:
			texture = background_texture;;
			parent->selectPrev ();
		break;

		case SDLK_RETURN:
			MenuSystem::showMenu (link);
		break;

		default:
			// meeh
		break;
	}
}
