#ifndef SWITCH_TEXT_BUTTON
#define SWITCH_TEXT_BUTTON

#include <iostream>

#include "textbutton.h"
#include "menufactory.h"

using std::string;

namespace SimpleMenu 
{
	class SwitchTextButton : public TextButton
	{
		public:

		SwitchTextButton (TiXmlElement* menu_node, Frame* parent);
		~SwitchTextButton ();

		void handleKeyPress (SDL_keysym key);

		private:

		class SwitchTextButtonFactory : public Factory
		{
			public:

			SwitchTextButtonFactory ()
				: Factory ("switch-text-button", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new SwitchTextButton (menu_node, parent);
			}
		};

		static SwitchTextButtonFactory switch_text_button_factory;

		string link;
	};
}

#endif // SWITCH_TEXT_BUTTON
