#ifndef TEXT_BUTTON_H
#define TEXT_BUTTON_H

#include <iostream>
#include <string>

#include "widget.h"
#include "menufactory.h"
#include "../renderutil.h"
#include "../resourcehandler.h"
#include "../tinyxml/tinyxml.h"

using std::string;

namespace SimpleMenu
{
	class TextButton : public Widget
	{
		public:

		TextButton (TiXmlElement* menu_node, Frame* parent);
		TextButton (string text, string background_texture, string selected_texture, string id, Frame* parent);
		~TextButton ();

		void draw (float w, float h, float x, float y);
		void handleKeyPress (SDL_keysym key);
		void selected ();

		protected:

		string text;
		string alt_text;
		string background_texture;
		string selected_texture;
		string texture;

		int size;
		float padding;

		RenderUtil::TextAlignment text_alignment;

		private:

		class TextButtonFactory : public Factory
		{
			public:

			TextButtonFactory ()
				: Factory ("text-button", this) { }

			MenuObject* _create (TiXmlElement* menu_node, Frame* parent)
			{
				return new TextButton (menu_node, parent);
			}
		};

		static TextButtonFactory text_button_factory;
	};
}

#endif // TEXT_BUTTON_H
