#ifndef OBJECTFACTORY_H
#define OBJECTFACTORY_H

#include <map>
#include <string>

#include "baseobject.h"

using namespace std;

enum ObjectType {
	ROCK,
	EASYROCK,
	NORMALROCK,
	HARDROCK,
	GOAL,
	POWERUP
};

class ObjectFactory
{
	public:
	
	ObjectFactory ();
	~ObjectFactory ();

	BaseObject* createObject (string name, float x, float y);
	BaseObject* createObject (string name, TiXmlElement* object_node);

	private:
	
	map<string, ObjectType> lookup;
};

#endif // OBJECTFACTORY_H
