#ifndef OPENGLWINDOW_H
#define OPENGLWINDOW_H

#include <SDL/SDL.h>
#include <GL/gl.h>
#include <GL/glu.h>

/**
 * Class OpenGLWindow
 * ------------------
 * wrapper for creating a opengl window with SDL
 */
class OpenGLWindow {
/**
 * Public stuff
 */
public:
	/****************************
	 * Constructors/Destructors *
	 ****************************/
	
	/**
	 * Empty Constructor
	 */
	OpenGLWindow ();
	
	/**
	 * Destructor
	 */
	~OpenGLWindow ();
	
	/**************
	 * Operations *
	 **************/
	
	/**
	 * @param width - width of window
	 * @param height - height of window
	 * @param depth - color depth of window
	 * @param flags - used to pass on SDL flags
	 */
	void  setResolution (int width, int height, int depth, Uint32 flags);
		
	
	/**
	 * switches to fullscreen if windowed or reverse
	 */
	void  toggleFullscreen ();
		
	
	/**
	 * sets the caption of the window title
	 */
	void  setCaption (const char* caption);

/**
 * Private stuff
 */
private:
	/**********
	 * Fields *
	 **********/
	 SDL_Surface* display_buffer;
	 bool intialized;
	 int width;
	 int height;
	 int depth;
};
#endif //OPENGLWINDOW_H

