#include <iostream>
#include <cmath>

#include "powerup.h"
#include "renderutil.h"
#include "worldmodifier.h"

using namespace std;

PowerUp::PowerUp (float x, float y)
	:
	BaseObject (&powerupshape),
	powerupshape (this)
{
	powerupshape.x = x;
	powerupshape.y = y;
	powerupshape.sidelength = 0.2;
}

PowerUp::PowerUp (TiXmlElement* powerup_node)
	:
	BaseObject (&powerupshape),
	powerupshape (this)
{
	TiXmlElement* position_node = powerup_node->FirstChildElement ("position");

	if (position_node) {
		position_node->QueryFloatAttribute ("x", &powerupshape.x);
		position_node->QueryFloatAttribute ("y", &powerupshape.y);
		position_node->QueryFloatAttribute ("sidelength", &powerupshape.sidelength);
	}
}

PowerUp::~PowerUp ()
{
}

void PowerUp::draw ()
{
	RenderUtil::renderSquare (powerupshape.x,
									  powerupshape.y,
									  powerupshape.sidelength, "data/gfx/powerup.png");
}

TiXmlNode& PowerUp::getXMLRepresentation ()
{
	TiXmlElement* powerup_node = new TiXmlElement ("powerup");
	TiXmlElement position_node = ("position");

	position_node.SetDoubleAttribute ("x", powerupshape.x);
	position_node.SetDoubleAttribute ("y", powerupshape.y);
	position_node.SetDoubleAttribute ("sidelength", powerupshape.sidelength);

	powerup_node->InsertEndChild (position_node);

	return *powerup_node;
}


void PowerUp::PowerUpShape::manipulate (Player* player, WorldModifier& worldmodifier, float delta_t)
{
	player->collectPowerUp ();

	worldmodifier.deleteObject (powerup_p->getSignature ());
}
