#ifndef POWERUP_H
#define POWERUP_H

#include "baseobject.h"
#include "player.h"
#include "square.h"

class PowerUp : public BaseObject
{
	public:
	PowerUp (float x, float y);
	PowerUp (TiXmlElement* powerup_node);
	~PowerUp ();

	virtual void draw ();
	virtual void update (float delta_t, WorldModifier& worldmodifier) { }
	virtual TiXmlNode& getXMLRepresentation ();


	private:

	class PowerUpShape;
	friend class PowerUpShape;

	class PowerUpShape : public Square
	{
		public:
		PowerUpShape (PowerUp* powerup_p) { this->powerup_p = powerup_p; }
		
		void manipulate (Player* player, WorldModifier& worldmodifier, float delta_t);

		private:
		PowerUp* powerup_p;
	}powerupshape;
};

#endif // POWERUP_H
