#ifndef PROGRESS_H
#define PROGRESS_H

#include <vector>
#include <string>

using std::vector;
using std::string;

class Progress
{
	public:

	Progress (string progress_file);
	~Progress ();

	bool update (string level);
	void unlockLevel ();

	private:

	void loadProgress ();
	void saveProgress ();

	struct LevelInfo {
		string name;
		bool completed;
	};

	vector<LevelInfo> unlocked_levels;
	vector<LevelInfo> locked_levels;

	string progress_file;
};

#endif // PROGRESS_H
