#ifndef RENDERER_H
#define RENDERER_H

#include <vector>
#include <map>


#include "baseobject.h"
#include "defines.h"

//#define Tilemap vector< vector<BaseObject*> > 
//#define FreeObjects vector<BaseObject*> 

using namespace std;

class Renderer
{
	public:
	
	Renderer ();
	Renderer (Shape* shape);
	~Renderer ();

	void render (Tilemap& tilemap, float tile_size);
	void render (FreeObjects& freeobjects);
	void renderHook (Shape* shape);
	void drawBackdrop ();
	void setViewport (float x, float y, float zoom);
	void getViewport (float* x, float* y, float* zoom);
	void setZoom (float zoom);

	private:

// 	vector<BaseObject*> tilesInView ();

	float zoom;
	float viewport_x;
	float viewport_y;
	float viewport_height;
	bool renderhook_set;
	Shape* view_hook;
};

#endif // RENDERER_H
