#ifndef ROCK_H
#define ROCK_H

#include "particlesystem.h"
#include "baseobject.h"
#include "player.h"
#include "square.h"


enum Rocktype {
	indestructible,
	easy,
	normal,
	hard
};

class Rock : public BaseObject
{
	public:
	Rock (float x, float y, Rocktype type);
	Rock (TiXmlElement* rock_node);
	~Rock ();

	virtual void draw ();
	virtual void update (float delta_t, WorldModifier& worldmodifier);
	virtual TiXmlNode& getXMLRepresentation ();

	private:

	ParticleSystem* boulders;
	ParticleSystem* smokepuffs;
	Rocktype type;
	float damage;
	bool startup;
	bool player_on_rock;

	class RockShape;
	friend class RockShape;

	class RockShape : public Square
	{
		public:
		RockShape (Rock* rock_p) { this->rock_p = rock_p; }
		
		void manipulate (Player* player, WorldModifier& worldmodifier, float delta_t);

		private:
		Rock* rock_p;
	}rockshape;
};

#endif // ROCK_H
