#ifndef TEXTURE_ANIMATION_H
#define TEXTURE_ANIMATION_H

#include "animation.h"

class TextureAnimation : public AnimationObject 
{
	public:

	TextureAnimation (string texture_path, int frames, int sets, float rate);
	~TextureAnimation ();

	void draw (Position& position, Outline& outline);
	void setRate (float rate) { this->rate = rate; }
	void selectSet (float set);
	void selectFrame (int frame);

	private:
	GLuint texture;

	int frames;				// number of frames in animation
	int frame;				// current frame
	int sets;				// number of sets in animation
	float rate;				// frame switching rate
	float timer;

	float setcoord1;
	float setcoord2;
};
#endif // TEXTURE_ANIMATION_H
