#ifndef WORLD_MODIFIER_H
#define WORLD_MODIFIER_H

#include <vector>
#include <map>

#include "defines.h"
#include "baseobject.h"

using namespace std;

// class BaseObject;
class World;

class WorldModifier {
	public:

	WorldModifier (World* world);
	~WorldModifier ();

	void execute ();

	void deleteObject (long signature);
	void insertFreeObject (BaseObject* object);
	void insertTileObject (BaseObject* object, FreeObjects& row);

	private:

	void _deleteObject (long signature);
	void deleteTileObject (long signature);

	long generateSignature ();

	vector<long> objects_to_be_deleted;

	World* world;
	long signature_count;
};

#endif // WORLD_MODIFIER_H
